package MultiPluginSwitcher::CMS;

use strict;

sub add_form {
    my ($cb, $app, $template) = @_;
    return if $app->param('blog_id');

    my $plugin = MT->component('MultiPluginSwitcher');
    my $enable = $plugin->translate('enable');
    my $disable = $plugin->translate('disable');
    my $message = $plugin->translate('message');
    my $confirm_enable = $plugin->translate('Are you sure you want to enable this plugin?');
    my $confirm_disable = $plugin->translate('Are you sure you want to disable this plugin?');
    my $nocheck = $plugin->translate('No check');

    my $old = <<HERE;
  <h2 class="plugin-group-name"><mt:var name="plugin_folder"></h2>
HERE

    $old = quotemeta($old);

    my $new = <<HERE;
  <h2 class="plugin-group-name"><mt:var name="plugin_folder"></h2>
<form style="margin-bottom:10px" method="post" action="<mt:var name="script_url">" id="multi_plugin">
    <input type="hidden" name="__mode" value="plugin_multi_control" />
    <mt:if name="blog_id">
        <input type="hidden" name="blog_id" value="<mt:var name="blog_id">" />
    </mt:if>
    <input type="hidden" name="return_args" value="<mt:var name="return_args" escape="html">" />
    <input type="hidden" name="magic_token" value="<mt:var name="magic_token">" />
    <input type="hidden" name="plugins_data" id="plugins_data" value="" />
    <input type="button" class="action primary button disable" value="$disable">
    <input type="button" class="action button enable" value="$enable">
    <input type="checkbox" class="allcheck" /> $message
</form>
HERE

    $$template =~ s/$old/$new/;

    $old = <<HERE;
<h4 class="plugin-name">
HERE

    $old = quotemeta($old);

    $new = <<HERE;
<input class="enable_plugins" type="checkbox" value="<mt:var name="plugin_sig" escape="js">" style="float:left;margin:12px 12px 12px 11px" />
<h4 class="plugin-name" style="margin-left:25px">
HERE

    $$template =~ s/$old/$new/;

    $old = <<HERE;
  </mt:if>
</mt:loop>
HERE
    $old = quotemeta($old);

    $new = <<HERE;
  </mt:if>
</mt:loop>
    <input type="button" class="action primary button disable" value="$disable">
    <input type="button" class="action button enable" value="$enable">
    <input type="checkbox" class="allcheck" /> $message
HERE
    $$template =~ s/$old/$new/;

    $old = <<HERE;
<mt:setvarblock name="jq_js_include" append="1">
HERE
    $old = quotemeta($old);

    $new = <<HERE;
<mt:setvarblock name="jq_js_include" append="1">
    var counter = 0;
    jQuery('.disable').click(function() {
        var plugins_data = '';
        jQuery('.enable_plugins').each(function(){
            if (plugins_data != '') {
                if(jQuery(this).attr('checked')) {
                    plugins_data = plugins_data + ':' + jQuery(this).val() + "=1"; 
                    counter++;
                }
            } else {
                if(jQuery(this).attr('checked')) {
                    plugins_data = jQuery(this).val() + "=1"; 
                    counter++;
                }
            }
        });
        if (!counter) {
            alert('$nocheck');
            return false;
        }
        if (!confirm("$confirm_disable")) {
            return false;
        }
        jQuery('#plugins_data').val(plugins_data);
        jQuery('#multi_plugin').submit();
    });

    jQuery('.enable').click(function() {
        var plugins_data = '';
        jQuery('.enable_plugins').each(function(){
            if (plugins_data != '') {
                if(jQuery(this).attr('checked')) {
                    plugins_data = plugins_data + ':' + jQuery(this).val() + "=0"; 
                    counter++;
                }
            } else {
                if(jQuery(this).attr('checked')) {
                    plugins_data = jQuery(this).val() + "=0"; 
                    counter++;
                }
            }
        });
        if (!counter) {
            alert('$nocheck');
            return false;
        }
        if (!confirm("$confirm_enable")) {
            return false;
        }
        jQuery('#plugins_data').val(plugins_data);
        jQuery('#multi_plugin').submit();
    });

    jQuery('.allcheck').click(function() {
        if(jQuery(this).attr('checked')) {
            jQuery('.enable_plugins').each(function(){
                jQuery(this).attr('checked', true);
            });
        } else {
            jQuery('.enable_plugins').each(function(){
                jQuery(this).attr('checked', false);
            });
        }
    });
HERE
    $$template =~ s/$old/$new/;
}

sub plugin_multi_control {
    my $app = shift;

    $app->validate_magic or return;
    return unless $app->can_do('toggle_plugin_switch');

    my $plugins_data = $app->param('plugins_data') || '';
    return if !$plugins_data;

    my $cfg = $app->config;

    my @list = split(/:/, $plugins_data);
    for my $plugin_data (@list) {
       my ($plugin_sig, $state) = split(/=/, $plugin_data);
        if ( exists $MT::Plugins{$plugin_sig} ) {
            $cfg->PluginSwitch(
                $plugin_sig . '=' . ( $state eq '1' ? '0' : '1' ), 1 );
        }
    }
    $cfg->save_config;

    $app->add_return_arg( 'switched' => 1 );
    $app->call_return;
}

1;
